<template>
	<div class="row">
		<div class="col-2">
			<label for="tipo" class="form-label">Tipo Persona</label>
			<select
				class="form-select form-select-sm"
				v-model="form.tipoAgente"
				:disabled="disabled"
			>
				<option v-for="elem in tiposAgente" :value="elem" :key="elem.key">
					{{ elem.value }}
				</option>
			</select>
		</div>
		<div class="col-6" v-show="esPersonaFisica">
			<BusquedaDocumento v-model="form.persona" :disabled="disabled" />
		</div>
		<div class="col-4" v-show="form.tipoAgente != null">
			<label for="cuitcuil" class="form-label col-12">C.U.I.T / C.U.I.L</label>
			<div class="col-12">
				<input
					id="cuitcuil"
					type="text"
					class="form-control form-control-sm"
					placeholder="xx-xxxxxxxx-x"
					v-model.trim="form.cuitCuil"
					:disabled="disabled"
				/>
			</div>
		</div>
	</div>
	<div class="row" v-show="form.tipoAgente != null">
		<div class="col-6">
			<label for="nombreORazonSocial" class="form-label col-12"
				>Nombre y Apellido / Razón Social</label
			>
			<input
				id="nombreORazonSocial"
				type="text"
				class="form-control form-control-sm"
				v-model.trim="form.nombre"
				:disabled="disabled"
			/>
		</div>
		<div class="col-6">
			<div class="row">
				<div class="col-10">
					<label for="domicilio" class="form-label">Domicilio</label>
					<input
						id="domicilio"
						type="text"
						class="form-control form-control-sm"
						v-model.trim="form.domicilio"
						:disabled="disabled"
					/>
				</div>
				<div class="col-2">
					<label for="cp" class="form-label">C.P</label>
					<input
						id="cp"
						type="text"
						class="form-control form-control-sm"
						v-model.trim="form.cp"
						:disabled="disabled"
					/>
				</div>
			</div>
		</div>
	</div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import BusquedaDocumento from "./BusquedaDocumento.vue";
import { Titulo } from "@/entities/Titulo";
import { Persona } from "@/entities/Persona";
import Swal from "sweetalert2/dist/sweetalert2.js";

class TipoAgente {
	key: number;
	value: string;

	constructor(key: number, value: string) {
		this.key = key;
		this.value = value;
	}
}

export default defineComponent({
	name: "DatosPersona",
	components: { BusquedaDocumento },
	props: {
		titulo: {
			type: Titulo,
			required: false,
			default: undefined,
		},
		disabled: {
			type: Boolean,
			required: true,
			default: true,
		},
		isLoading: {
			type: Boolean,
			required: false,
			default: false,
		},
	},
	data() {
		return {
			tiposAgente: [] as TipoAgente[],
			form: {
				tipoAgente: undefined as TipoAgente | undefined,
				persona: undefined as Persona | undefined,
				cuitCuil: "" as string,
				nombre: "" as string,
				domicilio: "" as string,
				cp: "" as string,
			},
			initBusquedaDoc: true,
		};
	},
	computed: {
		persona() {
			return this.form.persona;
		},
		esPersonaFisica() {
			return this.form.tipoAgente != null && this.form.tipoAgente.key == 1;
		},
	},
	mounted() {
		this.tiposAgente.push(new TipoAgente(1, "Persona Física"));
		this.tiposAgente.push(new TipoAgente(2, "Persona Jurídica"));
	},
	methods: {
		getData() {
			if (!this.formIsValid()) {
				return undefined;
			}
			return this.form;
		},
		formIsValid(): boolean {
			if (typeof this.form.tipoAgente === "undefined") {
				Swal.fire({
					icon: "error",
					text: "Debe indicar el tipo de persona.",
				});
				return false;
			}

			// Es Persona Física
			if (this.form.tipoAgente.key == 1) {
				if (typeof this.form.persona === "undefined") {
					Swal.fire({
						icon: "error",
						text: "Debe indicar un tipo y número de documento",
					});
					return false;
				}
			}

			if (!this.cuitIsValid()) {
				Swal.fire({
					icon: "error",
					text: "Debe indicar un CUIT / CUIL válido",
				});
				return false;
			}

			if (this.form.nombre == "") {
				Swal.fire({
					icon: "error",
					text: "Debe indicar el nombre o razón social",
				});
				return false;
			}

			if (this.form.domicilio == "") {
				Swal.fire({
					icon: "error",
					text: "Debe indicar un domicilio",
				});
				return false;
			}

			if (this.form.cp == "") {
				Swal.fire({
					icon: "error",
					text: "Debe indicar un código postal",
				});
				return false;
			}

			return true;
		},
		cuitIsValid(): boolean {
			var cuit: string = this.form.cuitCuil;
			if (cuit == "") {
				return false;
			}

			var rta: Array<string> = cuit.split("-", 3);

			if (rta.length < 3 || rta.length > 3) {
				return false;
			}

			var parte0 = rta[0];
			var parte1 = rta[1];
			var parte2 = rta[2];
			return (
				parte0.length == 2 &&
				/^\d+$/.test(parte0) &&
				parte1.length == 8 &&
				/^\d+$/.test(parte1) &&
				parte2.length == 1 &&
				/^\d+$/.test(parte2)
			);
		},
		initForm() {
			this.form.tipoAgente = undefined;
			this.form.persona = undefined;
			this.form.cuitCuil = "";
			this.form.nombre = "";
			this.form.domicilio = "";
			this.form.cp = "";
		},
	},
	watch: {
		isLoading() {
			if (typeof this.titulo !== "undefined") {
				// Persona
				if (this.titulo.tipo_doc != null && this.titulo.nro_doc != null) {
					this.form.tipoAgente = this.tiposAgente[0];
					this.form.persona = new Persona(
						this.titulo.tipo_doc,
						this.titulo.nro_doc,
						this.titulo.domicilio,
						"",
						"",
						"",
						"",
						this.titulo.cp,
						"",
						this.titulo.ayn_o_razon_social,
						"",
						this.titulo.cuit
					);
				} else {
					this.form.tipoAgente = this.tiposAgente[1];
					this.form.persona = undefined;
				}
			}
		},
		persona(newPersona: Persona) {
			if (typeof newPersona !== "undefined") {
				this.form.domicilio = newPersona.domicilio;
				this.form.cp = newPersona.cp_legal;
				this.form.nombre = newPersona.ayn;
				this.form.cuitCuil = newPersona.nro_id_trib;
			} else {
				this.form.domicilio = "";
				this.form.cp = "";
				this.form.nombre = "";
				this.form.cuitCuil = "";
			}
		},
	},
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
